<?php

require_once dirname(__FILE__).'/config.php';

$smarty =& TemplateEngine::getInstance();

function readboosterquarantineFile()
{
	$filename = KEYWORD_BANNED_SITE_FILE;
	$file_contents = '';
	$handle = fopen($filename, "r");
	$size = filesize($filename);
	if($size > 0)
	{
		$file_contents = fread($handle, $size);
	}
	return $file_contents;
}


function checknCreatePhpFile($my_name)
{
	global $lang;
	$filename = KEYWORD_BANNED_SITE_FILE;
	$smarty =& TemplateEngine::getInstance();

	if (!file_exists($filename))
	{
		if (!file_exists(dirname($filename)))
		{
			mkdir(dirname($filename));
		}
		$handle = fopen($filename, 'w');
		$ok = fwrite($handle, ' ');
		fclose($handle);

		#.htaccess
		$htaccess = SHARE_DIR."/".$my_name."/.htaccess";
		$handle = fopen($htaccess, 'w');
		$okh = fwrite($handle, "deny from all");
		fclose($handle);

		if (!$ok)
		{
			$smarty->append('warning',$lang['bannedkwsite_cannot_create_file']);
		}
	}
}

function defaut($my_name,$my_url)
{
	global $lang, $Boost_php_ok;

	$code_for_banned_kw_site = "
		//--------------- Start bannedkwsite -----------------------<br>
		if(file_exists('plugins/bannedkwsite/msg_banned_kw_site.php')) {<br>
			&nbsp;&nbsp;require_once ('plugins/bannedkwsite/msg_banned_kw_site.php');<br>
			&nbsp;&nbsp;if (banned_kw_site(\$url)) {<br>
			&nbsp;&nbsp;&nbsp;&nbsp;  return;<br>
			&nbsp;&nbsp;}<br>
		}<br>
		//--------------- End bannedkwsite -------------------------";

	checknCreatePhpFile($my_name);
	$file_contents = readboosterquarantineFile();
	
	$config_manager =& MyConfigManager::getInstance();
	$CONFIG = $config_manager->getConfig();
	
	$filename = SCRIPT_ROOT_PATH.'/include/functions/basic.php';
	$file_contents_test = '';
	$handle = fopen($filename, "r");
	$size = filesize($filename);
	if($size > 0)
	{
		$file_contents_test = fread($handle, $size);
	}
   
	$contenu_array = explode("\n",$file_contents_test);
	
	for($i=0;$i<sizeof($contenu_array);$i++) {
		if (strstr($contenu_array[$i],'banned_kw_site')) {
			$banned_kw_site_exist = true;
			$Boost_php_ok = true;
			break;
		}
	} 
  
	if ($banned_kw_site_exist<>true) {
		rewriteboostphp($contenu_array,$code_for_banned_kw_site);
	}

	Buffer::str('<form action="'.$my_url.'" method="post">');
	Buffer::str('<table width="100%">');
	
	Buffer::str('<tr>');
	Buffer::str('<td colspan="2">');
	Buffer::str('<h2>'.$lang['bannedkwsite_label'].'</h2><br />');
	Buffer::str('</td>');
	Buffer::str('</tr>');
	
	Buffer::str('<tr>');
	Buffer::str('<td>');
	Buffer::str($lang['keyword_bannedkwsite']);
	Buffer::str('</td>');
	Buffer::str('<td>');
	Buffer::str('<input type="text" name="banned_keyword_site" value="'.$file_contents.'" />');
	Buffer::str('</td>');
	Buffer::str('</tr>');

	Buffer::str('<tr>');
	Buffer::str('<td>');
	Buffer::str($lang['bannedkwsite_comments']);
	Buffer::str('</td>');
	Buffer::str('</tr>');

	Buffer::str('<tr>');
	Buffer::str('<td colspan="2">');
	Buffer::str('<input type="hidden" name="do" value="updatebannedkeywordsite" />');
	Buffer::str('<br /><center><input type="submit" value="'.$lang['submit'].'" /></center>');
	Buffer::str('</td>');
	Buffer::str('<td>');

	Buffer::str('</table>');
	Buffer::str('</form>');
	
	Buffer::str('<h2>'.' '.'</h2>');

	if ($Boost_php_ok) {
		Buffer::str($lang['bannedkwsite_php_code_OK'].'<br><br>');
	} else {
		Buffer::str('<strong>'.$lang['bannedkwsitephp_update_ko'].'</strong><br>');
		Buffer::str($lang['bannedkwsite_php_code_KO'].'<br><br>');
	}
	
	Buffer::str('<div align=left><tt><big>'.$code_for_banned_kw_site.'</big></tt></div>');
}

function writebannedkeywordsite($my_name, $my_url)
{
	global $lang;

	$smarty =& TemplateEngine::getInstance();
	$myts =& MyTextSanitizer::getInstance();

	$handle = fopen(KEYWORD_BANNED_SITE_FILE, 'w');
	$banned_keyword_site = isset($_POST['banned_keyword_site']) ? $myts->stripSlashesGPC($_POST['banned_keyword_site']) : '';
	$ok = fwrite($handle, $banned_keyword_site);
	fclose($handle);

	#.htaccess
	$htaccess = SHARE_DIR."/".$my_name."/.htaccess";
	$handle = fopen($htaccess, 'w');
	$okh = fwrite($handle, "deny from all");
	fclose($handle);

	if ($ok)
	{
		$smarty->append('warning',$lang['bannedkwsite_update_ok']);
	}
	else
	{
		$smarty->append('warning',$lang['bannedkwsite_update_ok']); 
	}
}

function rewriteboostphp($contenu_array,$code_for_banned_kw_site)
{
		global $lang,$Boost_php_ok;
	
		$code_for_banned_kw_site_php = preg_replace(array('/<br>/','/&nbsp;/'),'',$code_for_banned_kw_site);
		$smarty =& TemplateEngine::getInstance();
		$myts =& MyTextSanitizer::getInstance();
	
		$handle = fopen(SCRIPT_ROOT_PATH.'/include/functions/basic.php', 'w');
	
		for($i=0;$i<sizeof($contenu_array);$i++) {
			if (strstr($contenu_array[$i],'get_manager(\'validation\')')) {
					$contenu_array[$i] .= $code_for_banned_kw_site_php;
					$Boost_php_ok = true;
			} else {
				$ok = false;
			}

			fwrite($handle, $contenu_array[$i]."\n");
		} 

	fclose($handle);

	if ($Boost_php_ok) {
		$smarty->append('warning',$lang['bannedkwsitephp_update_ok']);
	} else {
		$smarty->append('warning',$lang['bannedkwsitephp_update_ko']); 
	}
}


$do = isset($_POST['do']) ? $_POST['do'] : '';

switch($do)
{
	case 'updatebannedkeywordsite':
		writebannedkeywordsite($my_name, $my_url);
		break;
}

defaut($my_name,$my_url);
?>